using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Text.RegularExpressions;
using System.Collections;

namespace Multijogador
{
    public partial class Inicio : Form
    {

        public static Hashtable nomeJogoPortuguesIngles = new Hashtable();
        public static Hashtable nomeJogoInglesPortugues = new Hashtable();
        
        public Inicio()
        {
            InitializeComponent();
        }
        
        public String enviandoMensagem(String mensagem)
        {
            String host = txtIP.Text;
            int port = 1027;
            try
            {
                port = int.Parse(txtPorta.Text);
            }
            catch
            {
                MessageBox.Show("Nmero de porta invlida: " + txtPorta.Text + ". Utilizando porta padro 1027.");
                txtPorta.Text = "1027";
                port = 1027;
            }

            //BufferedReader br;
            //br = new BufferedReader(new InputStreamReader(System.in));

            System.Net.IPAddress addr = null;
            try
            {
                System.Net.IPAddress.TryParse(host, out addr);
            }
            catch (Exception uhe)
            {
                MessageBox.Show("Endereo do servidor invlido: " + host + ". Mensagem de erro:  '" + uhe.Message + "'.");
            }
            
            try
            {
                // Abrindo um socket
                //Socket m_socListener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                System.Net.IPAddress ipAdd = System.Net.IPAddress.Parse(host);
                System.Net.IPEndPoint remoteEP = new IPEndPoint(ipAdd, port);
                //Socket m_socClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                Socket m_socClient = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

                string resposta = "";
                try
                {
                    m_socClient.Connect(remoteEP);
                }
                catch (Exception exc)
                {
                    MessageBox.Show("No foi possvel se conectar com o servidor (" + host.ToString() + ":" + port.ToString() + "). " + exc.Message);
                    return null;
                }

                try
                {
                    String szData = mensagem;
                    byte[] byData = System.Text.Encoding.ASCII.GetBytes(szData);
                    int res = m_socClient.Send(byData);
                    //MessageBox.Show("Resposta " + res.ToString());
                }
                catch (SocketException se)
                {
                    MessageBox.Show(se.Message);
                }

                byte[] buffer = new byte[1024];

                int iRx = m_socClient.Receive(buffer);
                for (int i = 0; i < 1024; i++)
                {
                    if (buffer[i] == 0) break;
                    //MessageBox.Show(temp + " => " + iRx.ToString());
                    resposta += (char)buffer[i];
                }
                //MessageBox.Show(temp);
                return resposta;

            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            return "";
        }


        private void btnTeste_Click(object sender, EventArgs e)
        {
            String resposta = enviandoMensagem(MensagensDeRequisicao.listarJogos());
            if (resposta == null)
            {
                return;
            }

            //MessageBox.Show(resposta);

            DataTable dtJogos = new DataTable();

            dtJogos.Columns.Add(new DataColumn("idDoJogo", Type.GetType("System.String")));
            dtJogos.Columns.Add(new DataColumn("tipo", Type.GetType("System.String")));
            dtJogos.Columns.Add(new DataColumn("status", Type.GetType("System.String")));

            //MessageBox.Show(respostaSimplificada);

            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            DescricaoDeJogo[] jogos = resp.Jogos;

            if (jogos != null)
            {
                for (int i = 0; i < jogos.Length; i++)
                {


                    DataRow novaLinha = dtJogos.NewRow();
                    novaLinha["idDoJogo"] = jogos[i].identificadorDoJogo;
                    String tipo = jogos[i].tipoDoJogo;
                    if (nomeJogoInglesPortugues.Contains(tipo.ToLower()))
                    {
                        tipo = (String)nomeJogoInglesPortugues[tipo.ToLower()];
                    }
                    novaLinha["tipo"] = tipo;
                    String status = "Jogo em andamento.";
                    if (jogos[i].jogoEncerrado) status = "Encerrado.";
                    if (jogos[i].jogoEncerrado)
                    {
                        status = "Encerrado.";
                    }
                    else
                    {
                        if (jogos[i].esperandoJogadores)
                        {
                            status = "Aguardando jogadores.";
                        }

                    }
                    novaLinha["status"] = status;
                    dtJogos.Rows.Add(novaLinha);
                }
            }

            /*
            String resposta = enviandoMensagem("<REQUEST><RT>SERVER STATUS</RT></REQUEST>");
            if (resposta == null)
            {
                return;
            }
            String respostaSimplificada = resposta.Substring(160, resposta.Length - 260);
            
            Regex exp = new Regex(@"<(\d+)\:class manager\.(\w+)\:>", RegexOptions.IgnoreCase);

            MatchCollection MatchList = exp.Matches(respostaSimplificada);
            if (MatchList.Count > 0)
            {
                for (int i = 0; i < MatchList.Count; i++)
                {
                    String tipoDeJogo = MatchList[i].Groups[2].ToString();
                    DataRow novaLinha = dtJogos.NewRow();
                    novaLinha["idDoJogo"] = MatchList[i].Groups[1].ToString();
                    String tipo = MatchList[i].Groups[2].ToString();
                    if (nomeJogoInglesPortugues.Contains(tipo.ToLower()))
                    {
                        tipo = (String)nomeJogoInglesPortugues[tipo.ToLower()];
                    }
                    novaLinha["tipo"] = tipo;
                    novaLinha["status"] = "";
                    dtJogos.Rows.Add(novaLinha);

                    if (tipoDeJogo.Equals("TictactoeGame",StringComparison.CurrentCultureIgnoreCase))
                    {
                        lbJogos.Items.Add("jogo "+MatchList[i].Groups[1].ToString());
                        //MessageBox.Show(MatchList[i].Groups[1] + ":" + MatchList[i].Groups[2]);
                    }
                    
                }
            }
             * */
            dgvJogos.DataSource = dtJogos;
        }

        private void btnNovoJogo_Click(object sender, EventArgs e)
        {
            String tipoDoJogo = cmbNovoJogo.Text;
            if (nomeJogoPortuguesIngles.Contains(tipoDoJogo.ToLower()))
            {
                tipoDoJogo = (String)nomeJogoPortuguesIngles[tipoDoJogo.ToLower()];
            }

            //MessageBox.Show(tipoDoJogo);

            String resposta = enviandoMensagem(MensagensDeRequisicao.novoJogo(tipoDoJogo));

            //String respostaSimplificada = resposta.Substring(160, resposta.Length - 260);
            //MessageBox.Show(resposta);

            btnTeste_Click(sender, e);

        }

        private void lbJogos_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            int idJogo = 1;
            int idJogador = 1;
            try
            {
                idJogador = int.Parse(txtJogador.Text);
                //idJogo = int.Parse(lbJogos.SelectedItem.ToString().Replace("jogo ", ""));
                JogoDaVelha f = new JogoDaVelha(idJogo, idJogador, this);
                f.Show();
            }
            catch (Exception e2)
            {
                MessageBox.Show("Erro tentando ler id do jogador. " + e2.Message);
            }
 
        }


        private void btnGenerico_Click(object sender, EventArgs e)
        {
            /*
            int idJogador = int.Parse(txtJogador.Text);
            int idJogo = int.Parse(lbJogos.SelectedItem.ToString().Replace("jogo ", ""));

            JogadorGenericoFiguras f = new JogadorGenericoFiguras(idJogo, idJogador, this);
            f.Show();
             */
         
        }

        private void timMensagem_Tick(object sender, EventArgs e)
        {
            //MessageBox.Show("No foi possvel enviar a mensagem. Tempo expirado de conexo.");
            throw new Exception("tempo expirado");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            String resposta = "<SERVER ANSWER><STATUS>OK</STATUS><GENERAL ANSWER><ACTION PERFORMED>LISTING GAMES</ACTION PERFORMED></GENERAL ANSWER><SPECIFIC ANSWER><LIST GAMES><GAME><GID>0</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>false</WP><#PLAYERS>2</#PLAYERS></GAME><GAME><GID>1</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME><GAME><GID>2</GID><GT>chess</GT><ENDED>true</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME><GAME><GID>3</GID><GT>deflexion</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME></LIST GAMES></SPECIFIC ANSWER><GAME STATUS><GGSTATUS>NOTHING TO BE DONE</GGSTATUS></GAME STATUS></SERVER ANSWER>";
            RespostaDoServidor resp = new RespostaDoServidor("<SERVER ANSWER><STATUS>OK</STATUS><GENERAL ANSWER><ACTION PERFORMED>LISTING GAMES</ACTION PERFORMED></GENERAL ANSWER><SPECIFIC ANSWER><LIST GAMES><GAME><GID>0</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>false</WP><#PLAYERS>2</#PLAYERS></GAME><GAME><GID>1</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME><GAME><GID>2</GID><GT>chess</GT><ENDED>true</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME><GAME><GID>3</GID><GT>deflexion</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME></LIST GAMES></SPECIFIC ANSWER><GAME STATUS><GGSTATUS>NOTHING TO BE DONE</GGSTATUS></GAME STATUS></SERVER ANSWER>");


            Regex exp = new Regex(@"<STATUS>(\w+)</STATUS>", RegexOptions.IgnoreCase);
            MatchCollection MatchList = exp.Matches(resposta);
            DescricaoDeJogo[] Jogos;

            exp = new Regex(@"<LIST GAMES>(.+)</LIST GAMES>", RegexOptions.IgnoreCase);
            MatchList = exp.Matches(resposta);
            if (MatchList.Count > 0)
            {
                String xmlListaDeJogos = MatchList[0].Groups[1].ToString();

                //<GAME><GID>0</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME>
                exp = new Regex(@"(<GAME><GID>\d+</GID><GT>\w+</GT><ENDED>\w+</ENDED><WP>\w+</WP><#PLAYERS>\d+</#PLAYERS></GAME>)", RegexOptions.IgnoreCase);

                MatchList = exp.Matches(MatchList[0].Groups[1].ToString());
                if (MatchList.Count > 0)
                {
                    Jogos = new DescricaoDeJogo[MatchList.Count];
                    for (int i = 0; i < MatchList.Count; i++)
                    {
                        Jogos[i] = new DescricaoDeJogo(MatchList[i].Groups[1].ToString());
                        //Jogos[i].exibirDadosDoJogo();
                        MessageBox.Show(Jogos[i].exibirDadosDoJogo());
                    }
                }
            }
            else { MessageBox.Show(MatchList.Count.ToString()); }


            
            
            MessageBox.Show(resp.respostaDoServidor);
            //DescricaoDeJogo dj = new DescricaoDeJogo("<GAME><GID>1</GID><GT>tictactoe</GT><ENDED>false</ENDED><WP>true</WP><#PLAYERS>0</#PLAYERS></GAME>");
            //MessageBox.Show(dj.exibirDadosDoJogo());
        }

        private void dgvJogos_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            //MessageBox.Show(e.RowIndex.ToString());
            int id = e.RowIndex;
            if (id >= 0)
            {
                //MessageBox.Show(dgvJogos.Rows[id].Cells[0].Value.ToString() + "  " + dgvJogos.Rows[id].Cells[1].Value.ToString());

                int idJogador = -1;
                int idJogo = -1;
               // try
               // {
                    idJogador = int.Parse(txtJogador.Text);
                    idJogo = int.Parse(dgvJogos.Rows[id].Cells[0].Value.ToString());
                    String tipo = dgvJogos.Rows[id].Cells[1].Value.ToString();
                    JogadorGenericoFiguras f = new JogadorGenericoFiguras(idJogo, idJogador, tipo, chkUsarFiguras.Checked, this);
                    f.Show();
                //}
                //catch (Exception e2)
               // {
                //    MessageBox.Show("Erro tentando ler id do jogador. Linha selecionada: "+id+", jogador: + "+idJogador+", jogo: "+idJogo+". "+ e2.Message);
               // }

            }
        }

        private void Inicio_Load(object sender, EventArgs e)
        {
            nomeJogoPortuguesIngles["jogodavelha2d"] = "tictactoe";
            nomeJogoPortuguesIngles["damas"] = "checkers";
            nomeJogoPortuguesIngles["xadrez"] = "chess";
            nomeJogoPortuguesIngles["xadrezdinamico"] = "dynamicchess";
            nomeJogoPortuguesIngles["deflexion"] = "deflexion";

            nomeJogoInglesPortugues["deflexion"] = "Deflexion";
            nomeJogoInglesPortugues["tictactoe"] = "JogoDaVelha2D";
            nomeJogoInglesPortugues["checkers"] = "Damas";
            nomeJogoInglesPortugues["chess"] = "Xadrez";
            nomeJogoInglesPortugues["dynamicchess"] = "XadrezDinamico";

            DataTable dtJogos = new DataTable();
            dtJogos.Columns.Add(new DataColumn("idDoJogo", Type.GetType("System.String")));
            dtJogos.Columns.Add(new DataColumn("tipo", Type.GetType("System.String")));
            dtJogos.Columns.Add(new DataColumn("status", Type.GetType("System.String")));
            dgvJogos.DataSource = dtJogos;

            Random rand = new Random();
            int id = (int)(100 * rand.NextDouble());
            txtJogador.Text = id.ToString();
        }

        private void cmbNovoJogo_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void dgvJogos_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void btnCriarEEntrar_Click(object sender, EventArgs e)
        {
            String tipoDoJogo = cmbNovoJogo.Text;
            if (nomeJogoPortuguesIngles.Contains(tipoDoJogo.ToLower()))
            {
                tipoDoJogo = (String)nomeJogoPortuguesIngles[tipoDoJogo.ToLower()];
            }

            //MessageBox.Show(tipoDoJogo);

            String resposta = enviandoMensagem(MensagensDeRequisicao.novoJogo(tipoDoJogo));

            //String respostaSimplificada = resposta.Substring(160, resposta.Length - 260);
            //MessageBox.Show(resposta);

            btnTeste_Click(sender, e);

            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            if (resp.respostaAfirmativa)
            {
                int idJogador = -1;
                int idJogo = -1;
                idJogador = int.Parse(txtJogador.Text);
                idJogo = resp.identificadorDoJogo;
                JogadorGenericoFiguras f = new JogadorGenericoFiguras(idJogo, idJogador, tipoDoJogo, chkUsarFiguras.Checked, this);
                f.Show();

            }
        }
    }
}