using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Multijogador
{
    public partial class JogadorGenerico : Form
    {
        public String[,] tabuleiro;
        public Label[,] tabuleiroLabel;
        public int linhasDoTabuleiro = 0;
        public int colunasDoTabuleiro = 0;
        public int x0;
        public int y0;
        public int posicaoAtualX = -1;
        public int posicaoAtualY = -1;
        public int[] deslocamentoX = { 2, 1, -1, -2, -2, -1, 1, 2 };
	    public int[] deslocamentoY = { 1, 2, 2, 1, -1, -2, -2, -1 };
	    public int totalDeCelulas;
        public int tempoDeEspera;
        public long totalDeOperacoes;
        public long totalDeOperacoes2;
        int larguraLabel = 60;
        public Button[] botoesDeOperacoes = new Button[3];


        private enum tiposDeJogadores { Jogador1, Jogador2, Observador };
        private tiposDeJogadores jogadorAtual = tiposDeJogadores.Observador;
        private Form formPai;
        private int jogador;
        private int jogo;
        private bool observador = false;
        private Label[] tabLabel = new Label[9];
//        private bool botAtivado = false;
//        bool botJogou = false;

        public JogadorGenerico(int jogoId, int jogadorId, String tipoDeJogo, Form pai)
        {
            this.InitializeComponent();
            botoesDeOperacoes[0] = btnEncerrarTurno;
            botoesDeOperacoes[1] = btnHorario;
            botoesDeOperacoes[2] = btnAntiHorario;
            lblTitulo.Text = tipoDeJogo;
            jogador = jogadorId;
            jogo = jogoId;
            formPai = pai;
            //String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>join game</RT><GID>"+jogoId+"</GID><PLAYER>"+jogadorId+"</PLAYER></REQUEST>");
            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.entrarEmUmJogo(jogoId,jogadorId));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);

            String resposta2 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.estouNesteJogo(jogoId, jogadorId));
            RespostaDoServidor resp2 = new RespostaDoServidor(resposta2);

            if (resp2.respostaAfirmativa)
            {
                //MessageBox.Show("Voc EST neste jogo. " + resposta);
            }
            else
            {
                MessageBox.Show("Voc est entrando neste jogo apenas como observador. " + resposta);
                observador = true;
                timer1.Enabled = true;
                lblTurno.Text = "Observando Jogo";
            }

            String resposta3 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.receberTabuleiro(jogoId, jogadorId));
            RespostaDoServidor resp3 = new RespostaDoServidor(resposta3);

            linhasDoTabuleiro = resp3.linhas;
            colunasDoTabuleiro = resp3.colunas;

            tabuleiro = resp3.tabuleiro;

            iniciarTabuleiro();
            verificarTurno(resp3);
            
            if (resposta.Contains("WAITING"))
            {
                jogadorAtual = tiposDeJogadores.Jogador1;
                lblJogadorAtual.Text = "Jogador1: X";
                //lblStatus.Text = "aguardando jogador2 O";
                //timer1.Enabled = true;
            }
            else
            {
                //String resposta2 = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>game status</RT><GID>" + jogoId + "</GID><PLAYER>" + jogadorId + "</PLAYER></REQUEST>");
                Regex exp = new Regex(@"<PLAYERS>(.*);(.*);</PLAYERS>", RegexOptions.IgnoreCase);
                MatchCollection MatchList = exp.Matches(resposta);
                //int[] tabuleiro = new int[9];
                //MessageBox.Show(MatchList.Count.ToString() + "  " + resposta);
                if (MatchList.Count > 0)
                {
                    int tempJog = int.Parse(MatchList[0].Groups[1].ToString());
                    if (tempJog == jogador)
                    {
                        jogadorAtual = tiposDeJogadores.Jogador1;
                        lblJogadorAtual.Text = "Jogador1: X";
                    }
                    else
                    {
                        tempJog = int.Parse(MatchList[0].Groups[2].ToString());
                        if (tempJog == jogador)
                        {
                            jogadorAtual = tiposDeJogadores.Jogador2;
                            lblJogadorAtual.Text = "Jogador2: O";
                        }
                        else
                        {
                            jogadorAtual = tiposDeJogadores.Observador;
                            lblJogadorAtual.Text = "Observando Jogo.";
                            //timer1.Enabled = true;
                            //timer1.Interval = 5000;
                        }
                    }
                }
            }



        }

        /*
        private string[,] leTabuleiro()
        {
            String resposta = @"Resposta: <SERVER ANSWER><STATUS>OK</STATUS><GENERAL ANSWER><ACTION PERFORMED>SHOWING GAME BOARD</ACTION PERFORMED></GENERAL ANSWER><SPECIFIC ANSWER><GID>2</GID><GAME CURRENT BOARD>< >< >< >< ><XObeX><XPhaX><XObeX><XP$/X>< >< >< >< ><XP\$X>< >< >< >< >< >< >< >< >< >< ><OP/$O>< >< >< >< >< >< ><XP$\X>< ><OP\$O>< ><XD\$X><XD$/X>< ><XP$/X>< ><OP/$O><XP$/X>< ><OP/$O>< ><OD/$O><OD$\O>< ><XP$\X>< ><OP\$O>< >< >< >< >< >< ><XP$/X>< >< >< >< >< >< >< >< >< >< ><OP$\O>< >< >< >< ><OP/$O><OObeO><OPhaO><OObeO>< >< >< >< ></GAME CURRENT BOARD><LINES>8</LINES><COLUMNS>10</COLUMNS><GAME INFO> </GAME INFO></SPECIFIC ANSWER><GAME STATUS><GGSTATUS>ADVERSARY'S TURN</GGSTATUS><PLAYERNUMBER>1</PLAYERNUMBER></GAME STATUS></SERVER ANSWER>";
            string[,] tabuleiro;
            tabuleiro = new string[8, 8];
            Regex exp = new Regex(@"<GAME CURRENT BOARD>(.+)</GAME CURRENT BOARD>", RegexOptions.IgnoreCase);
            MatchCollection MatchList = exp.Matches(resposta);
            if (MatchList.Count > 0)
            {
                String textoTabuleiro = MatchList[0].Groups[1].ToString();
                exp = new Regex(@"<(.+)>", RegexOptions.IgnoreCase);

                MatchList = exp.Matches(textoTabuleiro);
                if (MatchList.Count > 0)
                {
                  
                    for (int i = 0; i < MatchList.Count; i++)
                    {
                        int x = i % 8;
                        int y = i - 8 * x;
                        tabuleiro[x, y] = MatchList[i].Groups[1].ToString();
                        MessageBox.Show(tabuleiro[x, y]);
                    }
                }
            }
            else return null;
            return tabuleiro;
        }
         */ 

        private void button1_Click(object sender, EventArgs e)
        {
            //iniciarTabuleiro();
            //resolverAtumoticamente(x0, y0);
        }

        private void iniciarTabuleiro()
        {

            posicaoAtualX = -1;
            posicaoAtualY = -1;

            totalDeCelulas = linhasDoTabuleiro * colunasDoTabuleiro;
            
            //tabuleiro = new int[LINH, tamanho];
            tabuleiroLabel = new Label[linhasDoTabuleiro, colunasDoTabuleiro];


            for (int i = 0; i < colunasDoTabuleiro; i++)
            {
                for (int j = 0; j < linhasDoTabuleiro; j++)
                {
                    //tabuleiro[j, i] = "0";
                    Label lbl1 = new Label();
                    lbl1.Name = "l1";
                    lbl1.TextAlign = ContentAlignment.MiddleCenter;
                    lbl1.Font = lblTitulo.Font;
                    int id = i + colunasDoTabuleiro * j;
                    lbl1.Text = tabuleiro[j, i];
                    lbl1.Visible = true;
                    lbl1.AutoSize = false;
                    lbl1.Width = larguraLabel;
                    lbl1.Height = larguraLabel;
                    lbl1.BackColor = Color.White;
                    lbl1.Location = new System.Drawing.Point(i * (larguraLabel + 1) + 50, j * (larguraLabel + 1) + 50);
                    lbl1.Click += new System.EventHandler(cliqueDoUsuario);
                    lbl1.DoubleClick += new System.EventHandler(duploCliqueDoUsuario);
                    lbl1.MouseUp += new System.Windows.Forms.MouseEventHandler(soltouMouse);
                    tabuleiroLabel[j, i] = lbl1;
                    grpTabuleiro.Controls.Add(lbl1);
                }
            }
        }

        private void cliqueDoUsuario(object sender, EventArgs e)
        {
            Label clicado = ((Label)sender);

            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int coluna = (clicado.Location.X - posicaoInicial.X) / (larguraLabel + 1);
            int linha = (clicado.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);

            if (posicaoAtualX != -1 && posicaoAtualY != -1)
            {
                Label anterior = tabuleiroLabel[posicaoAtualX, posicaoAtualY];
                int colunaAnterior = (anterior.Location.X - posicaoInicial.X) / (larguraLabel + 1);
                int linhaAnterior = (anterior.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);

                mover(linhaAnterior,colunaAnterior,linha,coluna);
            }
            else
            {
                posicaoAtualX = linha;
                posicaoAtualY = coluna;
                tabuleiroLabel[linha, coluna].BackColor = Color.LightGreen;
            }

            /*
                    clicado.BackColor = Color.Green;
                    posicaoAtualX += distX;
                    posicaoAtualY += distY;
                    anterior.BackColor = Color.White;
             */
            //MessageBox.Show("Posicao clicada: linha " + distX +", coluna "+distY);
        }

        private void mover(int l1, int c1, int l2, int c2)
        {

            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.moverPeca(jogo, jogador, l1, c1,l2,c2));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            tabuleiroLabel[l1, c1].BackColor = Color.White;
            if (resp.respostaAfirmativa)
            {
                totalDeOperacoes++;
                posicaoAtualX = -1;
                posicaoAtualY = -1;
                atualizarTabuleiro();
            }
            else
            {
                //MessageBox.Show("No foi possvel mover de (" + linhaAnterior + "," + colunaAnterior + ") para (" + linha + "," + coluna + "). " + resposta);
                if (posicaoAtualX > -1)
                {
                    tabuleiroLabel[posicaoAtualX, posicaoAtualY].BackColor = Color.White;
                }
                posicaoAtualX = l2;
                posicaoAtualY = c2;
                tabuleiroLabel[l2, c2].BackColor = Color.LightGreen;
            }
        }

        private void duploCliqueDoUsuario(object sender, EventArgs e)
        {
            Label clicado = ((Label)sender);

            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int coluna = (clicado.Location.X - posicaoInicial.X) / (larguraLabel + 1);
            int linha = (clicado.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);


            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.adicionarPeca(jogo, jogador, linha, coluna));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            if (posicaoAtualX != -1 && posicaoAtualY != -1)
            {
                Label anterior = tabuleiroLabel[posicaoAtualX, posicaoAtualY];
                int colunaAnterior = (anterior.Location.X - posicaoInicial.X) / (larguraLabel + 1);
                int linhaAnterior = (anterior.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);

                tabuleiroLabel[linhaAnterior, colunaAnterior].BackColor = Color.White;
            }
            if (resp.respostaAfirmativa)
            {
                int operacoesRealizadas = (int.Parse(lblOperacoes.Text) + 1);
                lblOperacoes.Text = operacoesRealizadas.ToString();
                posicaoAtualX = -1;
                posicaoAtualY = -1;
                atualizarTabuleiro();
            }
            else
            {
                posicaoAtualX = linha;
                posicaoAtualY = coluna;
                tabuleiroLabel[linha, coluna].BackColor = Color.LightGreen;
            }
        }
    



        private void btnTabuleiro_Click(object sender, EventArgs e)
        {
            iniciarTabuleiro();
        }

        private void atualizarTabuleiro()
        {
            String resposta3 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.receberTabuleiro(jogo, jogador));
            RespostaDoServidor resp3 = new RespostaDoServidor(resposta3);
            tabuleiro = resp3.tabuleiro;

            for (int i = 0; i < colunasDoTabuleiro; i++)
            {
                for (int j = 0; j < linhasDoTabuleiro; j++)
                {
                    tabuleiroLabel[j,i].Text = tabuleiro[j, i];
                }
            }
            lblOperacoes.Text = totalDeOperacoes.ToString();
            verificarTurno(resp3);
        }

        private void verificarTurno(RespostaDoServidor resp)
        {
            bool ativarBotoes = false;

            if (resp.jogoEncerrado)
            {
                timer1.Enabled = false;
                if (resp.jogoEmpatado)
                {
                    lblTurno.Text = "Jogo Empatado";
                }
                else
                    if (!observador)
                    {
                        if (resp.vencedor == jogador)
                        {

                            lblTurno.Text = "Voc Venceu";
                        }
                    }
                    else
                    {
                        lblTurno.Text = "Jogo Encerrado";
                    }
            }
            else if (!observador)
            {
                if (resp.aguardandoJogadores)
                {
                    lblTurno.Text = "Aguardando Jogador";
                    timer1.Enabled = true;
                }
                else
                {
                    if (resp.turnoDoJogadorAtual)
                    {
                        ativarBotoes = true;
                        lblTurno.Text = "Seu Turno";
                        for (int i = 0; i < botoesDeOperacoes.Length; i++)
                        {
                            botoesDeOperacoes[i].Enabled = true;
                        }
                        grpTabuleiro.Enabled = true;
                        timer1.Enabled = false;
                    }
                    else
                    {
                        lblTurno.Text = "Turno do Adversrio";
                        timer1.Enabled = true;
                    }
                }
            }

            if (!ativarBotoes)
            {
                for (int i = 0; i < botoesDeOperacoes.Length; i++)
                {
                    botoesDeOperacoes[i].Enabled = false;
                }
                grpTabuleiro.Enabled = false;
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //iniciarTabuleiro();
        }

        private void cbAtraso_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                timer1.Interval = int.Parse(cbAtraso.Text) * 1000;
            }
            catch
            {
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            atualizarTabuleiro();
        }

        private void JogadorGenerico_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Enabled = false;
        }

        private void btnEncerrarTurno_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.finalizarTurno(jogo, jogador));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            if (!resp.respostaAfirmativa)
            {
                MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
            }
            else
            {

                atualizarTabuleiro();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (posicaoAtualX >= 0 && posicaoAtualY >= 0)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.rotacionarPeca(jogo, jogador, posicaoAtualX, posicaoAtualY, MensagensDeRequisicao.TipoDeOrientacao.SentidoHorario));
                RespostaDoServidor resp = new RespostaDoServidor(resposta);
                if (!resp.respostaAfirmativa)
                {
                    MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
                }
                else
                {
                    totalDeOperacoes++;
                    atualizarTabuleiro();
                }
            }
            else
            {
                MessageBox.Show(" necessrio selecionar uma pea.");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (posicaoAtualX >= 0 && posicaoAtualY >= 0)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.rotacionarPeca(jogo, jogador, posicaoAtualX, posicaoAtualY, MensagensDeRequisicao.TipoDeOrientacao.SentidoAntiHorario));
                RespostaDoServidor resp = new RespostaDoServidor(resposta);
                if (!resp.respostaAfirmativa)
                {
                    MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
                }
                else
                {
                    totalDeOperacoes++;

                    atualizarTabuleiro();
                }
            }
            else
            {
                MessageBox.Show(" necessrio selecionar uma pea.");
            }
        }

        private void testaMouseMove(object sender, MouseEventArgs e)
        {
            MessageBox.Show(""+e.X + e.Y);
        }

        private void soltouMouse(object sender, MouseEventArgs e)
        {

            Label clicado = ((Label)sender);

            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int colunaOriginal = (clicado.Location.X - posicaoInicial.X) / (larguraLabel + 1);
            int linhaOriginal = (clicado.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);


            int posicaoFinalX = e.Location.X;
            int posicaoFinalY = e.Location.Y;
            int coluna = (posicaoFinalX - posicaoInicial.X+5) / (larguraLabel + 1) + colunaOriginal;
            int linha = (posicaoFinalY - posicaoInicial.Y+larguraLabel/2) / (larguraLabel + 1) + linhaOriginal;
            
            //MessageBox.Show("Movendo de (" + linhaOriginal + "," + colunaOriginal+") para (" + linha + "," + coluna+")");
            if (linhaOriginal == linha || colunaOriginal == coluna)
            {
                mover(linhaOriginal, colunaOriginal, linha, coluna);
            }

        }

    }
}