using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Collections;

namespace Multijogador
{
    public partial class JogadorGenericoFiguras : Form
    {

        public Color corJogador2 = Color.GreenYellow;
        public Color corJogador1 = Color.Firebrick;
        private Point mouseDown = new Point(-1,-1);
        public String[,] tabuleiro;
        public Label[,] tabuleiroLabel;
        public PictureBox[,] tabuleiroFiguras;
        public int linhasDoTabuleiro = 0;
        public int colunasDoTabuleiro = 0;
        public int x0;
        public int y0;
        public int posicaoAtualX = -1;
        public int posicaoAtualY = -1;
        public int[] deslocamentoX = { 2, 1, -1, -2, -2, -1, 1, 2 };
	    public int[] deslocamentoY = { 1, 2, 2, 1, -1, -2, -2, -1 };
	    public int totalDeCelulas;
        public int tempoDeEspera;
        public long totalDeOperacoes;
        public long totalDeOperacoes2;
        int larguraLabel = 65;
        private int distanciaInicialX = 5;
        private int distanciaInicialY = 10;
        public Button[] botoesDeOperacoes = new Button[3];
        public Hashtable pecasConhecidas = new Hashtable();
        

        private enum tiposDeJogadores { Jogador1, Jogador2, Observador };
        private enum tiposDeFundo {Xadrez, Deflexion, Desconhecido};
        private tiposDeFundo fundoAtual = tiposDeFundo.Desconhecido;
        private tiposDeJogadores jogadorAtual = tiposDeJogadores.Observador;
        private Form formPai;
        private int jogador;
        private int jogo;
        private bool observador = false;
        private Label[] tabLabel = new Label[9];
        //private bool botAtivado = false;
        //bool botJogou = false;

        public JogadorGenericoFiguras(int jogoId, int jogadorId, String tipoDeJogo, bool usarFiguras, Form pai)
        {
            this.InitializeComponent();

            if (usarFiguras)
            {
                // JOGO DA VELHA
                pecasConhecidas.Add("+", Multijogador.Properties.Resources.pecaPadraoX);
                pecasConhecidas.Add("-", Multijogador.Properties.Resources.pecaPadraoO);
                // DAMAS
                pecasConhecidas.Add("x", Multijogador.Properties.Resources.pecaPadraoX);
                pecasConhecidas.Add("o", Multijogador.Properties.Resources.pecaPadraoO);
                pecasConhecidas.Add("X", Multijogador.Properties.Resources.pecaPadraoXX);
                pecasConhecidas.Add("O", Multijogador.Properties.Resources.pecaPadraoOO);
                // DEFLEXION
                pecasConhecidas.Add(@"XP$\X", Multijogador.Properties.Resources.pecaXPNE);
                pecasConhecidas.Add(@"XP/$X", Multijogador.Properties.Resources.pecaXPNO);
                pecasConhecidas.Add(@"XP$/X", Multijogador.Properties.Resources.pecaXPSE);
                pecasConhecidas.Add(@"XP\$X", Multijogador.Properties.Resources.pecaXPSO);
                pecasConhecidas.Add(@"XD$\X", Multijogador.Properties.Resources.pecaXDNE);
                pecasConhecidas.Add(@"XD/$X", Multijogador.Properties.Resources.pecaXDNO);
                pecasConhecidas.Add(@"XD$/X", Multijogador.Properties.Resources.pecaXDSE);
                pecasConhecidas.Add(@"XD\$X", Multijogador.Properties.Resources.pecaXDSO);
                pecasConhecidas.Add(@"XPhaX", Multijogador.Properties.Resources.pecaXPha);
                pecasConhecidas.Add(@"XObeX", Multijogador.Properties.Resources.pecaXObe);
                pecasConhecidas.Add(@"OP$\O", Multijogador.Properties.Resources.pecaOPNE);
                pecasConhecidas.Add(@"OP/$O", Multijogador.Properties.Resources.pecaOPNO);
                pecasConhecidas.Add(@"OP$/O", Multijogador.Properties.Resources.pecaOPSE);
                pecasConhecidas.Add(@"OP\$O", Multijogador.Properties.Resources.pecaOPSO);
                pecasConhecidas.Add(@"OD$\O", Multijogador.Properties.Resources.pecaODNE);
                pecasConhecidas.Add(@"OD/$O", Multijogador.Properties.Resources.pecaODNO);
                pecasConhecidas.Add(@"OD$/O", Multijogador.Properties.Resources.pecaODSE);
                pecasConhecidas.Add(@"OD\$O", Multijogador.Properties.Resources.pecaODSO);
                pecasConhecidas.Add(@"OPhaO", Multijogador.Properties.Resources.pecaOPha);
                pecasConhecidas.Add(@"OObeO", Multijogador.Properties.Resources.pecaOObe);
                // XADREZ
                pecasConhecidas.Add("XPawX", Multijogador.Properties.Resources.pecaPeaoB);
                pecasConhecidas.Add("XKinX", Multijogador.Properties.Resources.pecaReiB);
                pecasConhecidas.Add("XQueX", Multijogador.Properties.Resources.pecaRainhaB);
                pecasConhecidas.Add("XRooX", Multijogador.Properties.Resources.pecaTorreB);
                pecasConhecidas.Add("XKniX", Multijogador.Properties.Resources.pecaCavaloB);
                pecasConhecidas.Add("XBisX", Multijogador.Properties.Resources.pecaBispoB);
                pecasConhecidas.Add("OPawO", Multijogador.Properties.Resources.pecaPeaoP);
                pecasConhecidas.Add("OKinO", Multijogador.Properties.Resources.pecaReiP);
                pecasConhecidas.Add("OQueO", Multijogador.Properties.Resources.pecaRainhaP);
                pecasConhecidas.Add("ORooO", Multijogador.Properties.Resources.pecaTorreP);
                pecasConhecidas.Add("OKniO", Multijogador.Properties.Resources.pecaCavaloP);
                pecasConhecidas.Add("OBisO", Multijogador.Properties.Resources.pecaBispoP);
            }

            if (tipoDeJogo.Equals("deflexion",StringComparison.CurrentCultureIgnoreCase)){
                fundoAtual = tiposDeFundo.Deflexion;
            }
            else if (tipoDeJogo.Contains("xadrez") || tipoDeJogo.Contains("Xadrez") || tipoDeJogo.Contains("Chess"))
            {
                   fundoAtual = tiposDeFundo.Xadrez;
            }else if(tipoDeJogo.Contains("damas")||tipoDeJogo.Contains("Damas")){
                   fundoAtual = tiposDeFundo.Xadrez;
            }

            botoesDeOperacoes[0] = btnEncerrarTurno;
            botoesDeOperacoes[1] = btnHorario;
            botoesDeOperacoes[2] = btnAntiHorario;
            lblTitulo.Text = tipoDeJogo;
            jogador = jogadorId;
            jogo = jogoId;
            formPai = pai;
            //String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>join game</RT><GID>"+jogoId+"</GID><PLAYER>"+jogadorId+"</PLAYER></REQUEST>");
            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.entrarEmUmJogo(jogoId,jogadorId));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);

            String resposta2 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.estouNesteJogo(jogoId, jogadorId));
            RespostaDoServidor resp2 = new RespostaDoServidor(resposta2);

            if (resp2.respostaAfirmativa)
            {
                //MessageBox.Show("Voc EST neste jogo. " + resposta);
            }
            else
            {
                MessageBox.Show("Voc est entrando neste jogo apenas como observador.");
                observador = true;
                timer1.Enabled = true;
                lblTurno.Text = "Observando Jogo";
            }

            String resposta3 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.receberTabuleiro(jogoId, jogadorId));
            RespostaDoServidor resp3 = new RespostaDoServidor(resposta3);

            linhasDoTabuleiro = resp3.linhas;
            colunasDoTabuleiro = resp3.colunas;

            tabuleiro = resp3.tabuleiro;

            iniciarTabuleiro();
            verificarTurno(resp3);
            
            if (resposta.Contains("WAITING"))
            {
                jogadorAtual = tiposDeJogadores.Jogador1;
                //lblJogadorAtual.Text = "Jogador1: X";
                //lblStatus.Text = "aguardando jogador2 O";
                //timer1.Enabled = true;
            }
            else
            {
                //String resposta2 = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>game status</RT><GID>" + jogoId + "</GID><PLAYER>" + jogadorId + "</PLAYER></REQUEST>");
                Regex exp = new Regex(@"<PLAYERS>(.*);(.*);</PLAYERS>", RegexOptions.IgnoreCase);
                MatchCollection MatchList = exp.Matches(resposta);
                //int[] tabuleiro = new int[9];
                //MessageBox.Show(MatchList.Count.ToString() + "  " + resposta);
                if (MatchList.Count > 0)
                {
                    int tempJog = int.Parse(MatchList[0].Groups[1].ToString());
                    if (tempJog == jogador)
                    {
                        jogadorAtual = tiposDeJogadores.Jogador1;
                        //lblJogadorAtual.Text = "Jogador1: X";
                    }
                    else
                    {
                        tempJog = int.Parse(MatchList[0].Groups[2].ToString());
                        if (tempJog == jogador)
                        {
                            jogadorAtual = tiposDeJogadores.Jogador2;
                            //lblJogadorAtual.Text = "Jogador2: O";
                        }
                        else
                        {
                            jogadorAtual = tiposDeJogadores.Observador;
                            //lblJogadorAtual.Text = "Observando Jogo.";
                            //timer1.Enabled = true;
                            //timer1.Interval = 5000;
                        }
                    }
                }
            }



        }

        /*
        private string[,] leTabuleiro()
        {
            String resposta = @"Resposta: <SERVER ANSWER><STATUS>OK</STATUS><GENERAL ANSWER><ACTION PERFORMED>SHOWING GAME BOARD</ACTION PERFORMED></GENERAL ANSWER><SPECIFIC ANSWER><GID>2</GID><GAME CURRENT BOARD>< >< >< >< ><XObeX><XPhaX><XObeX><XP$/X>< >< >< >< ><XP\$X>< >< >< >< >< >< >< >< >< >< ><OP/$O>< >< >< >< >< >< ><XP$\X>< ><OP\$O>< ><XD\$X><XD$/X>< ><XP$/X>< ><OP/$O><XP$/X>< ><OP/$O>< ><OD/$O><OD$\O>< ><XP$\X>< ><OP\$O>< >< >< >< >< >< ><XP$/X>< >< >< >< >< >< >< >< >< >< ><OP$\O>< >< >< >< ><OP/$O><OObeO><OPhaO><OObeO>< >< >< >< ></GAME CURRENT BOARD><LINES>8</LINES><COLUMNS>10</COLUMNS><GAME INFO> </GAME INFO></SPECIFIC ANSWER><GAME STATUS><GGSTATUS>ADVERSARY'S TURN</GGSTATUS><PLAYERNUMBER>1</PLAYERNUMBER></GAME STATUS></SERVER ANSWER>";
            string[,] tabuleiro;
            tabuleiro = new string[8, 8];
            Regex exp = new Regex(@"<GAME CURRENT BOARD>(.+)</GAME CURRENT BOARD>", RegexOptions.IgnoreCase);
            MatchCollection MatchList = exp.Matches(resposta);
            if (MatchList.Count > 0)
            {
                String textoTabuleiro = MatchList[0].Groups[1].ToString();
                exp = new Regex(@"<(.+)>", RegexOptions.IgnoreCase);

                MatchList = exp.Matches(textoTabuleiro);
                if (MatchList.Count > 0)
                {
                  
                    for (int i = 0; i < MatchList.Count; i++)
                    {
                        int x = i % 8;
                        int y = i - 8 * x;
                        tabuleiro[x, y] = MatchList[i].Groups[1].ToString();
                        MessageBox.Show(tabuleiro[x, y]);
                    }
                }
            }
            else return null;
            return tabuleiro;
        }
         */ 

        private void button1_Click(object sender, EventArgs e)
        {
            //iniciarTabuleiro();
            //resolverAtumoticamente(x0, y0);
        }

        private void iniciarTabuleiro()
        {

            posicaoAtualX = -1;
            posicaoAtualY = -1;

            totalDeCelulas = linhasDoTabuleiro * colunasDoTabuleiro;

            //tabuleiro = new int[LINH, tamanho];
            tabuleiroLabel = new Label[linhasDoTabuleiro, colunasDoTabuleiro];
            tabuleiroFiguras = new PictureBox[linhasDoTabuleiro, colunasDoTabuleiro];
            grpTabuleiro.Width = (larguraLabel + 1) * colunasDoTabuleiro + 8;
            grpTabuleiro.Height = (larguraLabel + 1) * linhasDoTabuleiro + 13;

            Point temp = new Point(grpTabuleiro.Location.X + grpTabuleiro.Width + 5, 0);
            for (int i = 0; i < botoesDeOperacoes.Length; i++)
            {
                temp.Y = botoesDeOperacoes[i].Location.Y;
                botoesDeOperacoes[i].Location = temp;
            }
            temp.Y = lblOperacoes.Location.Y;
            lblOperacoes.Location = temp;
            temp.Y = lblOperacoesRotulo.Location.Y;
            lblOperacoesRotulo.Location = temp;
            temp.Y = lblAtualizar.Location.Y;
            lblAtualizar.Location = temp;
            temp.Y = cbAtraso.Location.Y;
            cbAtraso.Location = temp;

            this.Width = 25 + lblOperacoes.Width + lblOperacoes.Location.X;
            this.Height = 40 + Math.Max(lblOperacoes.Location.Y + lblOperacoes.Height, grpTabuleiro.Location.Y + grpTabuleiro.Height);

            lblTurno.Location = new Point(lblTitulo.Location.X + lblTitulo.Width + 25, lblTurno.Location.Y);
            lblTurno.Width = this.Width - lblTurno.Location.X - 80;

            for (int i = 0; i < colunasDoTabuleiro; i++)
            {
                for (int j = 0; j < linhasDoTabuleiro; j++)
                {
                    //tabuleiro[j, i] = "0";
                    Label lbl1 = new Label();
                    lbl1.Name = "l1";
                    lbl1.TextAlign = ContentAlignment.MiddleCenter;
                    lbl1.Font = lblTitulo.Font;
                    int id = i + colunasDoTabuleiro * j;
                    String textoPeca = tabuleiro[j, i];
                    lbl1.Text = textoPeca;
                    if (textoPeca != "" && textoPeca != " ")
                    {
                        if (textoPeca.StartsWith("o", StringComparison.CurrentCultureIgnoreCase))
                        {
                            lbl1.ForeColor = corJogador1;
                        }
                        else
                        {
                            lbl1.ForeColor = corJogador2;
                        }
                    }
                    lbl1.Visible = false;
                    lbl1.AutoSize = false;
                    lbl1.Width = larguraLabel;
                    lbl1.Height = larguraLabel;

                    lbl1.Location = new System.Drawing.Point(i * (larguraLabel + 1) + distanciaInicialX, j * (larguraLabel + 1) + distanciaInicialY);
                    lbl1.MouseClick += new System.Windows.Forms.MouseEventHandler(cliqueDoUsuario);
                    lbl1.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(duploCliqueDoUsuario);
                    //lbl1.MouseUp += new System.Windows.Forms.MouseEventHandler(soltouMouse);
                    //                    lbl1.MouseUp += new System.Windows.Forms.MouseEventHandler(apertouOMouse);
                    tabuleiroLabel[j, i] = lbl1;

                    Image imagemDeFundo = fundo(fundoAtual, j, i);
                    /*if (!(tabuleiro[j, i] == "" || tabuleiro[j,i] == " "))
                    {
                        //TODO
                        if (pecasConhecidas.Contains(tabuleiro[j, i]))
                        {
                            */
                    PictureBox pct1 = new PictureBox();
                    if (imagemDeFundo == null)
                    {
                        lbl1.BackColor = Color.White;

                    }
                    else
                    {
                        lbl1.BackColor = Color.Transparent;
                    }
                    lbl1.Image = imagemDeFundo;

                    pct1.Name = "l1";
                    pct1.Visible = true;
                    if (pecasConhecidas.Contains(tabuleiro[j, i]))
                    {
                        pct1.Image = (System.Drawing.Image)pecasConhecidas[tabuleiro[j, i]];
                        pct1.BackColor = Color.Transparent;
                    }
                    else if (!(tabuleiro[j, i] == "" || tabuleiro[j, i] == " "))
                    {
                        pct1.Visible = false;
                        lbl1.Visible = true;
                    }

                    //pct1.TextAlign = ContentAlignment.MiddleCenter;

                    
                    if (imagemDeFundo == null)
                    {
                        pct1.BackColor = Color.White;
                    }
                    else
                    {
                        pct1.BackgroundImage = imagemDeFundo;

                    }

                    pct1.AutoSize = false;
                    pct1.Width = larguraLabel;
                    pct1.Height = larguraLabel;
                    pct1.Location = new System.Drawing.Point(i * (larguraLabel + 1) + distanciaInicialX, j * (larguraLabel + 1) + distanciaInicialY);
                    pct1.MouseClick += new System.Windows.Forms.MouseEventHandler(cliqueDoUsuario);
                    pct1.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(duploCliqueDoUsuario);
                    //pct1.MouseUp += new System.Windows.Forms.MouseEventHandler(soltouMouse);
                    tabuleiroFiguras[j, i] = pct1;
                    grpTabuleiro.Controls.Add(pct1);
                    /*
                        }
                        else
                        {
                            //MessageBox.Show("Pea no encontrada: '" + tabuleiro[j, i] + "'");
                        }
             
                        
                    }
                        */
                    grpTabuleiro.Controls.Add(lbl1);

                }
            }
        }

        private void cliqueDoUsuario(object sender, MouseEventArgs e)
        {
            Point clicado = retornaPosicao(sender);
            mouseDown.X = e.X;
            mouseDown.Y = e.Y;
            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int coluna = (clicado.X - posicaoInicial.X) / (larguraLabel + 1);
            int linha = (clicado.Y - posicaoInicial.Y) / (larguraLabel + 1);

            if (posicaoAtualX != -1 && posicaoAtualY != -1)
            {
                Label anterior = tabuleiroLabel[posicaoAtualX, posicaoAtualY];
                int colunaAnterior = (anterior.Location.X - posicaoInicial.X) / (larguraLabel + 1);
                int linhaAnterior = (anterior.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);

                mover(linhaAnterior,colunaAnterior,linha,coluna);
            }
            else
            {
                posicaoAtualX = linha;
                posicaoAtualY = coluna;
                tabuleiroLabel[linha, coluna].BackColor = Color.LightGreen;
                
                if (tabuleiroFiguras[linha, coluna] != null)
                {
                    tabuleiroFiguras[linha, coluna].BackColor = Color.LightGreen;
                    tabuleiroFiguras[linha, coluna].BackgroundImage = null;
                    tabuleiroLabel[linha, coluna].Image = null;

                }
            }

            /*
                    clicado.BackColor = Color.Green;
                    posicaoAtualX += distX;
                    posicaoAtualY += distY;
                    anterior.BackColor = Color.White;
             */
            //MessageBox.Show("Posicao clicada: linha " + distX +", coluna "+distY);
        }

        private void mover(int l1, int c1, int l2, int c2)
        {
            if (l2 < linhasDoTabuleiro && c2 < colunasDoTabuleiro)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.moverPeca(jogo, jogador, l1, c1, l2, c2));
                RespostaDoServidor resp = new RespostaDoServidor(resposta);
                tabuleiroLabel[l1, c1].BackColor = Color.White;
                if (tabuleiroFiguras[l1, c1] != null)
                {
                    Image imagemDeFundo = fundo(fundoAtual, l1, c1);
                    if (imagemDeFundo == null)
                    {
                        tabuleiroFiguras[l1, c1].BackColor = Color.White;
                    }
                    else
                    {
                        tabuleiroFiguras[l1, c1].BackgroundImage = imagemDeFundo;
                        tabuleiroLabel[l1, c1].Image = imagemDeFundo;
                    }

                    tabuleiroFiguras[l1, c1].BackColor = Color.White;
                }

                if (resp.respostaAfirmativa)
                {
                    totalDeOperacoes++;
                    posicaoAtualX = -1;
                    posicaoAtualY = -1;
                    atualizarTabuleiro();
                }
                else
                {
                    //MessageBox.Show("No foi possvel mover de (" + linhaAnterior + "," + colunaAnterior + ") para (" + linha + "," + coluna + "). " + resposta);
                    if (posicaoAtualX > -1)
                    {
                        tabuleiroLabel[posicaoAtualX, posicaoAtualY].BackColor = Color.White;
                    }
                    posicaoAtualX = l2;
                    posicaoAtualY = c2;

                    tabuleiroLabel[l2, c2].BackColor = Color.LightGreen;
                    if (tabuleiroFiguras[l2, c2] != null)
                    {
                        tabuleiroFiguras[l2, c2].BackColor = Color.LightGreen;
                        tabuleiroFiguras[l2, c2].BackgroundImage = null;
                        tabuleiroLabel[l2, c2].Image = null;
                    }

                }
            }
        }

        private void duploCliqueDoUsuario(object sender, MouseEventArgs e)
        {
            //Label clicado = ((Label)sender);
            Point clicado = retornaPosicao(sender);

            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int coluna = (clicado.X - posicaoInicial.X) / (larguraLabel + 1);
            int linha = (clicado.Y - posicaoInicial.Y) / (larguraLabel + 1);


            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.adicionarPeca(jogo, jogador, linha, coluna));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            if (posicaoAtualX != -1 && posicaoAtualY != -1)
            {
                Label anterior = tabuleiroLabel[posicaoAtualX, posicaoAtualY];
                int colunaAnterior = (anterior.Location.X - posicaoInicial.X) / (larguraLabel + 1);
                int linhaAnterior = (anterior.Location.Y - posicaoInicial.Y) / (larguraLabel + 1);

                tabuleiroLabel[linhaAnterior, colunaAnterior].BackColor = Color.White;
                if (tabuleiroFiguras[linha, coluna] != null)
                {
                    tabuleiroFiguras[linha, coluna].BackColor = Color.White;
                }
            }
            if (resp.respostaAfirmativa)
            {
                int operacoesRealizadas = (int.Parse(lblOperacoes.Text) + 1);
                lblOperacoes.Text = operacoesRealizadas.ToString();
                posicaoAtualX = -1;
                posicaoAtualY = -1;
                atualizarTabuleiro();
            }
            else
            {
                posicaoAtualX = linha;
                posicaoAtualY = coluna;
                tabuleiroLabel[linha, coluna].BackColor = Color.LightGreen;
            }
        }
    



        private void btnTabuleiro_Click(object sender, EventArgs e)
        {
            iniciarTabuleiro();
        }

        private void atualizarTabuleiro()
        {
            String resposta3 = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.receberTabuleiro(jogo, jogador));
            RespostaDoServidor resp3 = new RespostaDoServidor(resposta3);
            tabuleiro = resp3.tabuleiro;

            for (int i = 0; i < colunasDoTabuleiro; i++)
            {
                for (int j = 0; j < linhasDoTabuleiro; j++)
                {
                    String textoPeca = tabuleiro[j, i];
                    tabuleiroLabel[j, i].Text = textoPeca;
                    if (textoPeca != "" && textoPeca != " ")
                    {
                        if (textoPeca.StartsWith("o", StringComparison.CurrentCultureIgnoreCase))
                        {
                            tabuleiroLabel[j, i].ForeColor = corJogador1;
                        }
                        else
                        {
                            tabuleiroLabel[j, i].ForeColor = corJogador2;
                        }
                    }

                    /*
                    if (tabuleiroFiguras[j, i] != null)
                    {
                        grpTabuleiro.Controls.Remove(tabuleiroFiguras[j, i]);
                    }
                    
                    if (!(tabuleiro[j, i] == "" || tabuleiro[j, i] == " "))
                    {
                        if (pecasConhecidas.Contains(tabuleiro[j, i]))
                        {
                            PictureBox pct1 = new PictureBox();
                    */
                    PictureBox pct1 = tabuleiroFiguras[j, i];
                    //pct1.Name = "l1";
                    if (pecasConhecidas.Contains(tabuleiro[j, i]))
                    {
                        pct1.Image = (System.Drawing.Image)pecasConhecidas[tabuleiro[j, i]];
                        pct1.BackColor = Color.Transparent;
                        tabuleiroLabel[j, i].Visible = false;
                        pct1.Visible = true;
                    }
                    else
                    {
                        if (!(tabuleiro[j, i] == "" || tabuleiro[j, i] == " "))
                        {
                            tabuleiroLabel[j, i].Visible = true;
                            pct1.Visible = false;
                        }
                        else
                        {
                            pct1.Image = null;
                        }
                    }
                    Image imagemDeFundo = fundo(fundoAtual, j, i);
                    if (imagemDeFundo == null)
                    {
                        pct1.BackColor = Color.White;
                    }
                    else
                    {
                        pct1.BackgroundImage = imagemDeFundo;
                        tabuleiroLabel[j,i].Image = imagemDeFundo;
                    }
                    /*
                            pct1.Visible = true;
                            pct1.AutoSize = false;
                            pct1.Width = larguraLabel;
                            pct1.Height = larguraLabel;
                            pct1.Location = new System.Drawing.Point(i * (larguraLabel + 1) + distanciaInicialX, j * (larguraLabel + 1) + distanciaInicialY);
                            pct1.MouseClick += new System.Windows.Forms.MouseEventHandler(cliqueDoUsuario);
                            pct1.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(duploCliqueDoUsuario);
                            //pct1.MouseUp += new System.Windows.Forms.MouseEventHandler(soltouMouse);
                     
                            tabuleiroFiguras[j, i] = pct1;
                            tabuleiroLabel[j, i].Visible = false;
                    
                    grpTabuleiro.Controls.Add(pct1);
                       }
                       else
                       {
                           //MessageBox.Show("Pea no encontrada: '" + tabuleiro[j, i] + "'");
                       }
                   }
                     */
                }
            }
            lblOperacoes.Text = totalDeOperacoes.ToString();
            verificarTurno(resp3);
        }

        private void verificarTurno(RespostaDoServidor resp)
        {
            bool ativarBotoes = false;

            if (resp.jogoEncerrado)
            {
                timer1.Enabled = false;
                if (resp.jogoEmpatado)
                {
                    lblTurno.Text = "Jogo Empatado";
                }
                else
                    if (!observador)
                    {
                        if (resp.vencedor == jogador)
                        {

                            lblTurno.Text = "Voc Venceu";
                        }
                    }
                    else
                    {
                        lblTurno.Text = "Jogo Encerrado";
                    }
            }
            else if (!observador)
            {
                if (resp.aguardandoJogadores)
                {
                    lblTurno.Text = "Aguardando Jogador";
                    timer1.Enabled = true;
                }
                else
                {
                    if (resp.turnoDoJogadorAtual)
                    {
                        ativarBotoes = true;
                        lblTurno.Text = "Seu Turno";
                        for (int i = 0; i < botoesDeOperacoes.Length; i++)
                        {
                            botoesDeOperacoes[i].Enabled = true;
                        }
                        grpTabuleiro.Enabled = true;
                        timer1.Enabled = false;
                    }
                    else
                    {
                        lblTurno.Text = "Turno do Adversrio";
                        timer1.Enabled = true;
                    }
                }
            }

            if (!ativarBotoes)
            {
                for (int i = 0; i < botoesDeOperacoes.Length; i++)
                {
                    botoesDeOperacoes[i].Enabled = false;
                }
                grpTabuleiro.Enabled = false;
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //iniciarTabuleiro();

        }

        private void cbAtraso_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                timer1.Interval = int.Parse(cbAtraso.Text) * 1000;
            }
            catch
            {
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            atualizarTabuleiro();
        }

        private void JogadorGenerico_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Enabled = false;
        }

        private void btnEncerrarTurno_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.finalizarTurno(jogo, jogador));
            RespostaDoServidor resp = new RespostaDoServidor(resposta);
            if (!resp.respostaAfirmativa)
            {
                MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
            }
            else
            {

                atualizarTabuleiro();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (posicaoAtualX >= 0 && posicaoAtualY >= 0)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.rotacionarPeca(jogo, jogador, posicaoAtualX, posicaoAtualY, MensagensDeRequisicao.TipoDeOrientacao.SentidoHorario));
                RespostaDoServidor resp = new RespostaDoServidor(resposta);
                if (!resp.respostaAfirmativa)
                {
                    MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
                }
                else
                {
                    totalDeOperacoes++;
                    atualizarTabuleiro();
                }
            }
            else
            {
                MessageBox.Show(" necessrio selecionar uma pea.");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (posicaoAtualX >= 0 && posicaoAtualY >= 0)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem(MensagensDeRequisicao.rotacionarPeca(jogo, jogador, posicaoAtualX, posicaoAtualY, MensagensDeRequisicao.TipoDeOrientacao.SentidoAntiHorario));
                RespostaDoServidor resp = new RespostaDoServidor(resposta);
                if (!resp.respostaAfirmativa)
                {
                    MessageBox.Show("No foi possvel finalizar o turno atual. Voc tem certeza de que isto  uma jogada vlida?");
                }
                else
                {
                    totalDeOperacoes++;

                    atualizarTabuleiro();
                }
            }
            else
            {
                MessageBox.Show(" necessrio selecionar uma pea.");
            }
        }

        private void testaMouseMove(object sender, MouseEventArgs e)
        {
            MessageBox.Show(""+e.X + e.Y);
        }

        private void apertouOMouse(object sender, MouseEventArgs e)
        {
            //mouseDown.X = e.X;
            //mouseDown.Y = e.Y;
        }

        private void soltouMouse(object sender, MouseEventArgs e)
        {
            Point clicado = retornaPosicao(sender);            
            Point posicaoInicial = new Point(tabuleiroLabel[0, 0].Location.X, tabuleiroLabel[0, 0].Location.Y);
            int colunaOriginal = (clicado.X - posicaoInicial.X) / (larguraLabel + 1);
            int linhaOriginal = (clicado.Y - posicaoInicial.Y) / (larguraLabel + 1);

            int posicaoFinalX = e.X;//.Location.X;
            int posicaoFinalY = e.Y;//Location.Y;
            int multiplicadorX = 1;
            int multiplicadorY = 1;
            if (posicaoAtualX > clicado.X) multiplicadorX = -1;
            if (posicaoAtualY > clicado.Y) multiplicadorY = -1;
            int coluna = (posicaoFinalX - posicaoInicial.X+multiplicadorX*larguraLabel/2) / (larguraLabel + 1) + colunaOriginal;
            int linha = (posicaoFinalY - posicaoInicial.Y+multiplicadorY*larguraLabel/2) / (larguraLabel + 1) + linhaOriginal;
            //int coluna = (posicaoFinalX - posicaoInicial.X) / (larguraLabel + 1);
            //int linha = (posicaoFinalY - posicaoInicial.Y+larguraLabel/2) / (larguraLabel + 1);
            int desX = e.X-mouseDown.X;
            int desY = e.Y-mouseDown.Y;

            MessageBox.Show("Movendo de (" + linhaOriginal + "," + colunaOriginal + ") para (" + linha + "," + coluna + ") deslocamento: (" + desX + ", " + desY+")");
            if (linhaOriginal == linha || colunaOriginal == coluna)
            {
                mover(linhaOriginal, colunaOriginal, linha, coluna);
            }

        }

        private System.Drawing.Image fundo(tiposDeFundo tipo, int x, int y)
        {
            if (tipo == tiposDeFundo.Xadrez){
                if ((x+y) % 2 != 0){
                    return Multijogador.Properties.Resources.fundoPadrao2;
                }else{
                    return null;
                }
            }else if (tipo == tiposDeFundo.Deflexion){
                if (y == 0) return Multijogador.Properties.Resources.fundoDourado;
                if (y == 9) return Multijogador.Properties.Resources.fundoPrateado;
                return Multijogador.Properties.Resources.fundoPadrao2;
            }
            return null;
        }

        private Point retornaPosicao(object objeto)
        {
            Point ponto = new Point(-1, -1);
            if (objeto.GetType() == lblTitulo.GetType())
            {
                Label clicado = ((Label)objeto);
                ponto.X = clicado.Location.X;
                ponto.Y = clicado.Location.Y;
            }
            else
            {
                PictureBox clicado = ((PictureBox)objeto);
                ponto.X = clicado.Location.X;
                ponto.Y = clicado.Location.Y;
            }
            return ponto;
        }

    }
}