using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Multijogador
{
    public partial class JogoDaVelha : Form
    {
        private enum tiposDeJogadores {Jogador1,Jogador2, Observador};
        private tiposDeJogadores jogadorAtual = tiposDeJogadores.Observador;
        private Form formPai;
        private int jogador;
        private int jogo;
        private Label[] tabLabel = new Label[9];
        private bool botAtivado = false;
        bool botJogou = false;
        public JogoDaVelha(int jogoId, int jogadorId, Form pai)
        {
            jogador = jogadorId;
            jogo = jogoId;
            formPai = pai;
            InitializeComponent();
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>join game</RT><GID>"+jogoId+"</GID><PLAYER>"+jogadorId+"</PLAYER></REQUEST>");
            if (resposta.Contains("WAITING"))
            {
                jogadorAtual = tiposDeJogadores.Jogador1;
                lblJogadorAtual.Text = "Jogador1: X";
                lblStatus.Text = "aguardando jogador2 O";
                timer1.Enabled = true;
            }
            else
            {
                //String resposta2 = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>game status</RT><GID>" + jogoId + "</GID><PLAYER>" + jogadorId + "</PLAYER></REQUEST>");
                Regex exp = new Regex(@"<PLAYERS>(.*);(.*);</PLAYERS>", RegexOptions.IgnoreCase);
                MatchCollection MatchList = exp.Matches(resposta);
                int[] tabuleiro = new int[9];
                //MessageBox.Show(MatchList.Count.ToString() + "  " + resposta);
                if (MatchList.Count > 0)
                {
                    int tempJog = int.Parse(MatchList[0].Groups[1].ToString());
                    if (tempJog == jogador)
                    {
                        jogadorAtual = tiposDeJogadores.Jogador1;
                        lblJogadorAtual.Text = "Jogador1: X";
                    }
                    else
                    {
                        tempJog = int.Parse(MatchList[0].Groups[2].ToString());
                        if (tempJog == jogador)
                        {
                            jogadorAtual = tiposDeJogadores.Jogador2;
                            lblJogadorAtual.Text = "Jogador2: O";
                        }
                        else
                        {
                            jogadorAtual = tiposDeJogadores.Observador;
                            lblJogadorAtual.Text = "Observando Jogo.";
                            timer1.Enabled = true;
                            timer1.Interval = 5000;
                        }
                    }
                }
            }


            //MessageBox.Show(resposta);

            resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>game board</RT><GID>"+jogoId+"</GID></REQUEST>");
            //MessageBox.Show(resposta);
            tabLabel[0] = lbl0;
            tabLabel[1] = lbl1;
            tabLabel[2] = lbl2;
            tabLabel[3] = lbl3;
            tabLabel[4] = lbl4;
            tabLabel[5] = lbl5;
            tabLabel[6] = lbl6;
            tabLabel[7] = lbl7;
            tabLabel[8] = lbl8;

            lerTabuleiro();          

            /*
            resposta = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>1</GID><PLAYER>1</PLAYER><X>1</X><Y>1</Y></REQUEST>");
            MessageBox.Show(resposta);
            resposta = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>1</GID><PLAYER>0</PLAYER><X>2</X><Y>2</Y></REQUEST>");
            MessageBox.Show(resposta);
            resposta = ((Form1)formPai).enviandoMensagem("<REQUEST><RT>GAME STATUS</RT><GID>" + jogoId + "</GID></REQUEST>");
            MessageBox.Show(resposta);
            */

        }

        private void lerTabuleiro()
        {
            String mensagem = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>game board</RT><GID>" + jogo + "</GID></REQUEST>");
            Regex exp = new Regex(@"<GAME CURRENT BOARD>(.+)</GAME CURRENT BOARD>", RegexOptions.IgnoreCase);
            Regex exp2 = new Regex(@"<(.)>", RegexOptions.IgnoreCase);
            MatchCollection MatchList = exp.Matches(mensagem);
            int[] tabuleiro = new int[9];
            if (MatchList.Count > 0)
            {
                mensagem = MatchList[0].Groups[1].ToString();
                //MessageBox.Show(mensagem);
                MatchList = exp2.Matches(mensagem);
                int nivel = 0;
                String tag = "";
                for (int i = 0; i < 9; i++)
                {
                    int valor = 0;

                    if (MatchList[nivel].Groups[1].ToString() == "-")
                    {
                        valor = -1;
                        tabLabel[i].Text = "O";
                    }
                    else if (MatchList[nivel].Groups[1].ToString() == "+")
                    {
                        valor = +1;
                        tabLabel[i].Text = "X";
                    }
                    tabuleiro[i] = valor;
                    tag += valor.ToString();
                    nivel++;
                }
                
                //MessageBox.Show(tag);
            }
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>GAME STATUS</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER></REQUEST>");
            if (!resposta.Contains("GAME ENDED")){
                  
                if (resposta.Contains("YOUR TURN"))
                {
                    lblStatus.Text = "seu turno";
                    if (botAtivado && !botJogou) jogarAutomaticamente();

                    timer1.Enabled = true;
                }else if (resposta.Contains("ADVERSARY'S TURN"))
                {
                    if (jogadorAtual != tiposDeJogadores.Observador) { lblStatus.Text = "turno do adversrio"; }
                    timer1.Enabled = true;
                }
                botJogou = false;
            }          
        }

        int retornaJogadaVitoriaDerrota(int[] TABULEIRO, int jog)
        {
            /* uma jogada de vitoria ou derrota  caracterizada por duas marcas 
             * seguidas com o mesmo valor e o terceiro valor livre                 */
            int valorAtual = jog;
            if (jogadorAtual == tiposDeJogadores.Jogador2) valorAtual = -1 * valorAtual;
            if ((TABULEIRO[0] + TABULEIRO[1] + TABULEIRO[2]) == 2 * valorAtual)
            {
                if (TABULEIRO[0] == 0) return 0;
                else if (TABULEIRO[1] == 0) return 1;
                else return 2;
            }
            if ((TABULEIRO[3] + TABULEIRO[4] + TABULEIRO[5]) == 2 * valorAtual)
            {
                if (TABULEIRO[3] == 0) return 3;
                else if (TABULEIRO[4] == 0) return 4;
                else return 5;
            }
            if ((TABULEIRO[6] + TABULEIRO[7] + TABULEIRO[8]) == 2 * valorAtual)
            {
                if (TABULEIRO[6] == 0) return 6;
                else if (TABULEIRO[7] == 0) return 7;
                else return 8;
            }
            if ((TABULEIRO[0] + TABULEIRO[3] + TABULEIRO[6]) == 2 * valorAtual)
            {
                if (TABULEIRO[0] == 0) return 0;
                else if (TABULEIRO[3] == 0) return 3;
                else return 6;
            }
            if ((TABULEIRO[1] + TABULEIRO[4] + TABULEIRO[7]) == 2 * valorAtual)
            {
                if (TABULEIRO[1] == 0) return 1;
                else if (TABULEIRO[4] == 0) return 4;
                else return 7;
            }
            if ((TABULEIRO[2] + TABULEIRO[5] + TABULEIRO[8]) == 2 * valorAtual)
            {
                if (TABULEIRO[2] == 0) return 2;
                else if (TABULEIRO[5] == 0) return 5;
                else return 8;
            }
            if ((TABULEIRO[2] + TABULEIRO[4] + TABULEIRO[6]) == 2 * valorAtual)
            {
                if (TABULEIRO[2] == 0) return 2;
                else if (TABULEIRO[4] == 0) return 4;
                else return 6;
            }
            if ((TABULEIRO[0] + TABULEIRO[4] + TABULEIRO[8]) == 2 * valorAtual)
            {
                if (TABULEIRO[0] == 0) return 0;
                else if (TABULEIRO[4] == 0) return 4;
                else return 8;
            }
            return -1;
        } /* retornaJogadaVitoriaDerrota */

	

        public int retornaOutraJogada(int[] TABULEIRO, int jog, int jogadasEfetuadas)
        {
            int res = -1;
            if (jogadasEfetuadas == 3)
            {
                if ((TABULEIRO[0] * TABULEIRO[8] == 1 || TABULEIRO[2] * TABULEIRO[6] == 1) && TABULEIRO[4] != 0)
                {
                    return 1;
                }       

                if ((TABULEIRO[1] * TABULEIRO[8] == 1 || TABULEIRO[0] * TABULEIRO[5] == 1 || TABULEIRO[1] * TABULEIRO[5] == 1) && TABULEIRO[4] != 0)
                {
                    return 2;
                }
            }



            // tente jogar no meio ou nas diagonais (maior chance de vitoria ou impedir derrota
            if (jogadasEfetuadas <= 2)
            {
                if (TABULEIRO[4] == 0) res = 4;
                else if (TABULEIRO[0] == 0) res = 0;
                else res = 8;
                return res;
            }
            else
            {
                res = -1;
                if (TABULEIRO[4] == 0) res = 4;
                else if (TABULEIRO[6] == 0) res = 6;
                else if (TABULEIRO[8] == 0) res = 8;
                else if (TABULEIRO[0] == 0) res = 0;
                else if (TABULEIRO[2] == 0) res = 2;
                if (res != -1)
                {
                    return res;
                }
            }
            for (int i = 0; i < 9; i++)
            {
                if (TABULEIRO[i] == 0) return i;
            }
            return -1;
        }



        public void jogarAutomaticamente()
        {
            if (lblStatus.Text == "seu turno")
            {
                int jogAtual = -1;
                if (jogadorAtual == tiposDeJogadores.Jogador2) jogAtual = 1;
                int[] TABULEIRO = new int[9];
                int jogadasDisponiveis = 0;
                for (int i = 0; i < 9; i++)
                {
                    if (tabLabel[i].Text == "X")
                    {
                        TABULEIRO[i] = -1;
                    }
                    else if (tabLabel[i].Text == "O")
                    {
                        TABULEIRO[i] = 1;
                    }else{
                        jogadasDisponiveis++;
                    }
                }


                int jogada = retornaJogadaVitoriaDerrota(TABULEIRO,jogAtual);
                if (jogada == -1) { jogada = retornaJogadaVitoriaDerrota(TABULEIRO, jogAtual*-1); }
                if (jogada == -1) { jogada = retornaOutraJogada(TABULEIRO, jogAtual,9-jogadasDisponiveis); }
                if (jogada > -1)
                {
                    int x = jogada / 3;
                    int y = jogada % 3;
                    String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>"+x+"</X><Y>"+y+"</Y></REQUEST>");
                    //MessageBox.Show(jogada + " " + resposta);
                    botJogou = true;
                    lerTabuleiro();
                }
            }
        }

        private void JogoDaVelha_Load(object sender, EventArgs e)
        {

        }

        private void lbl0_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>"+jogo+"</GID><PLAYER>"+jogador+"</PLAYER><X>0</X><Y>0</Y></REQUEST>");
            //MessageBox.Show(resposta);
            lerTabuleiro();
        }

        private void lbl1_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>0</X><Y>1</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl2_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>0</X><Y>2</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl3_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>1</X><Y>0</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl4_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>1</X><Y>1</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl5_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>1</X><Y>2</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl6_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>2</X><Y>0</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl7_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>2</X><Y>1</Y></REQUEST>");
            lerTabuleiro();
        }

        private void lbl8_Click(object sender, EventArgs e)
        {
            String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>add piece</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER><X>2</X><Y>2</Y></REQUEST>");
            lerTabuleiro();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (timer1.Enabled == true)
            {
                String resposta = ((Inicio)formPai).enviandoMensagem("<REQUEST><RT>GAME STATUS</RT><GID>" + jogo + "</GID><PLAYER>" + jogador + "</PLAYER></REQUEST>");
                if (resposta.Contains("YOUR TURN"))
                {
                    lblStatus.Text = "seu turno";
                    if (botAtivado) jogarAutomaticamente();
                    timer1.Enabled = false;
                    lerTabuleiro();
                }
                else
                {
                    if (resposta.Contains("GAME ENDED"))
                    {
                        lblStatus.Text = "fim de jogo";
                        timer1.Enabled = false;
                        lerTabuleiro();
                    }
                }
            }

        }

        private void btnBoot_Click(object sender, EventArgs e)
        {

            if (!botAtivado)
            {
                botAtivado = true;
                jogarAutomaticamente();
                btnBot.Text = "Desativar Bot";
            }
            else
            {
                btnBot.Text = "Ativar Bot";
                botAtivado = false;
            }


        }
    }
}