using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Multijogador
{
    static class MensagensDeRequisicao
    {
        public enum TipoDeJogo {JogoDaVelha2D,Xadrez,Damas,XadrezDinamico};
        public enum TipoDeOrientacao { SentidoHorario, SentidoAntiHorario};

        static public String receberTabuleiro(int identificadorDoJogo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>GAME BOARD</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER></REQUEST>";
        }

        //ROTATE PIECE:	<REQUEST><RT>ROTATE PIECE</RT><GID>[game_id]</GID><PLAYER>[player_id]</PLAYER><X>[x value]</X><Y>[y value]</Y><SENSE>[CLOCKWISE|ANTICLOCKWISE]</SENSE></REQUEST>
        static public String rotacionarPeca(int identificadorDoJogo, int identificadorDoJogador, int origemX, int origemY, TipoDeOrientacao sentido)
        {
            String orientacao = "CLOCKWISE";
            if (sentido == TipoDeOrientacao.SentidoAntiHorario) orientacao = "COUNTERCLOCKWISE";
            return "<REQUEST><RT>ROTATE PIECE</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER><X>" + origemX + "</X><Y>" + origemY + "</Y><SENSE>"+orientacao+"</SENSE></REQUEST>";
        }


        static public String estouNesteJogo(int identificadorDoJogo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>AM I IN THIS GAME</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER></REQUEST>";
        }

        static public String entrarEmUmJogo(int identificadorDoJogo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>join game</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER></REQUEST>";
        }


        static public String listarJogos()
        {
            return "<REQUEST><RT>LIST GAMES</RT></REQUEST>";
        }


        static public String novoJogo(String tipo)
        {
            return "<REQUEST><RT>new game</RT><GT>"+tipo+"</GT></REQUEST>";
            //<GAME_NAME>[string game name]</GAME_NAME>][<PLAYER>[|player1_id]</PLAYER>
        }

        static public String novoJogo(String tipo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>new game</RT><GT>" + tipo + "</GT><PLAYER>" + identificadorDoJogador + "</PLAYER></REQUEST>";
        }

        static public String novoJogo(String tipo, String descricaoDaInstanciaDoJogo)
        {
            return "<REQUEST><RT>new game</RT><GT>" + tipo + "</GT><GAME_NAME>"+descricaoDaInstanciaDoJogo+"</GAME_NAME></REQUEST>";
        }

        static public String novoJogo(String tipo, String descricaoDaInstanciaDoJogo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>new game</RT><GT>" + tipo + "</GT><GAME_NAME>" + descricaoDaInstanciaDoJogo + "</GAME_NAME><PLAYER>"+identificadorDoJogador+"</PLAYER></REQUEST>";
        }

        static public String moverPeca(int identificadorDoJogo, int identificadorDoJogador, int origemX, int origemY, int destinoX, int destinoY)
        {
            return "<REQUEST><RT>MOVE PIECE</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER><X>" + origemX + "</X><Y>" + origemY + "</Y><X2>" + destinoX + "</X2><Y2>" + destinoY + "</Y2></REQUEST>";
        }

        static public String adicionarPeca(int identificadorDoJogo, int identificadorDoJogador, int origemX, int origemY)
        {
            return "<REQUEST><RT>ADD PIECE</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER><X>" + origemX + "</X><Y>" + origemY + "</Y></REQUEST>";
        }


        static public String finalizarTurno(int identificadorDoJogo, int identificadorDoJogador)
        {
            return "<REQUEST><RT>END TURN</RT><GID>" + identificadorDoJogo + "</GID><PLAYER>" + identificadorDoJogador + "</PLAYER></REQUEST>";
        }


        static public String converteTipoDeJogoParaString(TipoDeJogo tipo)
        {
            if (tipo == TipoDeJogo.JogoDaVelha2D)
            {
                return "tictactoe";
            } else if (tipo == TipoDeJogo.Damas)
            {
                return "checkers";
            }
            else if (tipo == TipoDeJogo.Xadrez)
            {
                return "chess";
            }
            else if (tipo == TipoDeJogo.XadrezDinamico)
            {
                return "dinamicchess";
            } else if (tipo == TipoDeJogo.Damas)
            {
                return "chess";
            }
            return "JogoIndefinido";
        }


    }
}
